﻿using HeuristicLab.Common;
using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;

namespace HeuristicLab.Problems.Robocode {
  [StorableClass]
  public class GetEnergy : CodeNode, INumericalMethod {
    public override int MinimumArity { get { return 0; } }
    public override int MaximumArity { get { return 0; } }

    [Storable]
    public override string Prefix { get; set; }

    [Storable]
    public override string Suffix { get; set; }

    [StorableConstructor]
    private GetEnergy(bool deserializing) : base(deserializing) { }
    private GetEnergy(GetEnergy original, Cloner cloner)
      : base(original, cloner) {

    }

    public GetEnergy()
      : base("GetEnergy", "Returns the robot's current energy.") {
      this.Prefix = "getEnergy(";
      this.Suffix = ")";
    }

    public override IDeepCloneable Clone(Cloner cloner) {
      return new GetEnergy(this, cloner);
    }

    public override string Interpret(ISymbolicExpressionTreeNode node, System.Collections.Generic.IEnumerable<ISymbolicExpressionTreeNode> children) {
      return this.Prefix + this.Suffix;
    }
  }
}